<?php
require_once('/usr/local/pkg/ipqualityscore/ipqualityscore.inc');

global $config, $g, $ipqs;
$ipqs['fnc']['global_init']();
$ipqs['config']		= &$config['installedpackages']['ipqualityscore']['config'][0];
//stops people from calling the page directly.
if($_SERVER['PHP_SELF'] === '/ipqualityscore/.api.php'  && isset($_SERVER['REMOTE_ADDR']) && !in_array($_SERVER['REMOTE_ADDR'],['config']['gbl']['authorized'],true)){
    header($_SERVER["SERVER_PROTOCOL"]." 404 Not Found",true, 404);
    exit();
};


if(php_sapi_name() === 'cli'){
    $shrt  = "iqt";
    $lng = Array(
        "clear_oauth",
        "request_url_oauth",
        "response_url_oauth:",
        "install",
        "proxy_vpn:",
        "remove_blocked_addr:",
        "install",
        "ipqs_var",
        "uninstall::",
        "watchdog"
    );
    
    $opt = getopt($shrt,$lng);

    if(isset($opt['clear_oauth'])){
        $ipqs['config']['oauth']['access_token']    = '';
        $ipqs['config']['oauth']['domain']          = '';
    }

    if(isset($opt['i']) || isset($opt['install'])){
        $ipqs['installer']['fnc']['install']();
    }

    if(isset($opt['uninstall'])){
        if($opt['uninstall'] === "DELETE"){
            $ipqs['installer']['fnc']['uninstall']();
        }else{
            echo "\e[91m\e[1mYou Need to pass value \"DELETE\" to uninstall.\e[0m\n";
        }
    }


    if(isset($opt['proxy_vpn'])){
        if(!filter_var($opt['proxy_vpn'], FILTER_VALIDATE_IP, FILTER_FLAG_IPV4 | FILTER_FLAG_IPV6 | FILTER_FLAG_NO_PRIV_RANGE | FILTER_FLAG_NO_RES_RANGE)){
            exit();
        }

        /**
         * Do not delete, it's stops a flow loop from happening. so unless you plan
         * on burning your credits in a matter of minutes this is not a wise thing to
         * do.
         */
        if(isset($ipqs['config']['vpnproxy']['addr']['addr_'.$opt['proxy_vpn']])){
            $ipqs['fnc']['rmaddr']();
            if($ipqs['fnc']['is_cached']($opt['proxy_vpn'])) die();
        }

        $strict = isset($ipqs['config']['vpnproxy']['strictness']) ? $ipqs['config']['vpnproxy']['strictness'] : 1;
        $ap = isset($ipqs['config']['vpnproxy']['publicap'])? $ipqs['config']['vpnproxy']['publicap'] : false;
        
        /**
         * request data from IPQS.
         */
        $result =  $ipqs['fnc']['validateaddress']($opt['proxy_vpn'], $ipqs['config']['oauth']['access_token'], $ipqs['config']['oauth']['domain'], $strict,$ap);
        $arr = json_decode($result);

        /**
         * Stop netmon form spamming servers if there is a problem.
         */
        if($arr->success !== true){
            $ipqs['config']['vpnproxy']['enabled'] = '';
            $ipqs['bin']['stop']();
            echo "\e[31mYou require an oauth key to enable this product.\e[39m\n";
            write_config('Netmon failed');
            die();
        }

        /**
         * When the "t" switch is set we will add the ip to the alias if it fails to pass the params.
         */
        if(isset($opt['t'])){
            if(ipqs_validate_flags($result)) $ipqs['fnc']['blockaddr']($opt['proxy_vpn']);
            $ipqs['fnc']['add_cache'](trim($opt['proxy_vpn']));
            unset($arr);
        }else{
            echo $ipqs['fnc']['json_to_str']($result);
        }
        exit();
    }

    /**
     * creates the request url need for IPQS to gen oauth tokems.
     * 
     * @param string $request_url_oauth ipaddress in string form.
     */
    if(isset($opt['request_url_oauth'])){
        $uri = 'https://ipqualityscore.com/oauth/pfsense/login?domain=' . $_SERVER[HOST] . '&path=%2Fipqulaityscore%2Foauth.php';
        echo $uri . "\n";
        exit();
    }

    if(isset($opt['response_url_oauth'])){
        $puri = parse_url($opt['response_url_oauth'],-1);
        if(isset($puri['query'])){
            $q = explode('&', $puri['query']);
            $_get = Array();

            foreach($q as $itm){
                array_push($get, explode('=', $itm));
            }

            if(strlen($_get['access_token']) !== 128){
                echo "Invalid token";
            }else{
                $ipqs['config']['oauth']['access_token']    = $_get['access_token'];
                $ipqs['config']['oauth']['domain']          = $_get['domain'];
                write_config('Saved oauth config.');
                echo "Added new OAuth token. \n";
                exit();
            }
        }else{
            echo 'Bad url'."\n";
        }
        exit();
    }

    /**
     * Removes oauth keys from cofig.
     * 
     * @return void;
     */
    if(isset($opt['clear_oauth'])){
        $ipqs['fnc']['del_oauth']();
    }

    /**
     * debug details about the config.
     */
    if(isset($opt['ipqs_var'])){
        print_r($ipqs);
    }

    /**
     * this should be executed from a cron job to monitor is netmon is working
     */
    if (isset($opt['watchdog'])){
        $ipqs['bin']['watchdog'];
    }

    /**
     * To be used with cli.
     */
    if (isset($opt['enable'])){
        if(strlen($ipqs['oauth']['access_token'])!=128){
            echo "\e[31mYou Require an oauth key to enable this product.\e[39m \n";
            exit();
        }

        $ipqs['bin']['start']();
    }
}



/**
 * Test if a IPQS result shoudl block or allow the address.
 *
 * @param json $json
 * @return void
 */
function ipqs_validate_flags($json){
    global $config, $ipqs;
    $arr = json_decode($json);
    if(
        ($arr->vpn === true && in_array(1, explode(',',$ipqs['config']['vpnproxy']['block'])) === true)||
        ($arr->proxy === true && in_array(2, explode(',',$ipqs['config']['vpnproxy']['block']))) ||
        ($arr->tor === true && in_array(3, explode(',',$ipqs['config']['vpnproxy']['block']))) ||
        ($arr->fraud_score >= $ipqs['config']['vpnproxy']['fraud']) ||
        (in_array($arr->country, explode(',',$ipqs['config']['vpnproxy']['country'])))
    ){
        return true;
    }

    return false;
}